<template>
  <label
    class="ui-radio flex items-start text-base leading-snug outline-none lg:text-lg xl:text-xl"
    :class="[
      {
        'cursor-not-allowed text-gray-400': disabled,
        'cursor-pointer': !disabled,
        'focus-within:text-violet-700 hover:text-violet-700':
          !button && !disabled,
        'items-center rounded border-2 border-gray-400 px-4 py-3 shadow motion-safe:transition':
          button,
        'focus-within:border-violet-500 focus-within:ring-2 focus-within:ring-violet-300 focus-within:ring-opacity-75':
          button && !disabled,
        'bg-white hover:border-violet-500': button && !disabled && !checked,
        'border-violet-700 bg-violet-50 text-violet-900':
          button && !disabled && checked,
        'border-gray-300 bg-gray-50 shadow-none': button && disabled,
      },
      $attrs.class as string,
    ]"
    :style="$attrs.style as string"
    :for="uniqueId"
    :aria-labelledby="labelledById"
  >
    <input
      :id="uniqueId"
      v-model="model"
      :tabindex="computedTabindex"
      v-bind="{ ...filteredAttrs, ...filteredProps }"
      type="radio"
      class="peer absolute shrink-0 cursor-pointer opacity-0 disabled:cursor-not-allowed"
      :class="{
        'size-[1.25em]': !labelledById,
        'size-[2.75em]': labelledById,
      }"
    />
    <svg
      width="32"
      height="32"
      viewBox="-2 -2 36 36"
      aria-hidden="true"
      focusable="false"
      class="pointer-events-none shrink-0 rounded-full outline-none ring-violet-300 ring-opacity-75 peer-[&:focus:not(:focus-visible)]:ring-opacity-0 peer-checked:[&_.inner]:fill-violet-700 peer-checked:[&_.inner]:stroke-[8] peer-focus:[&_.outer]:stroke-violet-700 peer-checked:[&_circle]:stroke-violet-700 [&_circle]:motion-safe:transition-all"
      :class="{
        'peer-hover:text-violet-500 ': !disabled,
        'peer-focus:ring-2 ': !button,
        'size-[1.25em] ': !labelledById,
        'm-[0.625em] size-[1.5em]': labelledById,
      }"
    >
      <circle
        class="outer"
        r="16"
        cx="16"
        cy="16"
        stroke="currentColor"
        fill="none"
        :stroke-width="labelledById ? 3.333 : 4"
      />
      <circle class="inner" r="6" cx="16" cy="16" fill="none" />
    </svg>
    <span
      v-if="!labelledById"
      class="ml-2 motion-safe:transition-colors"
      :class="{
        'ml-3': button,
      }"
    >
      <slot>{{ label }}</slot>
    </span>
  </label>
</template>

<script lang="ts" setup>
import { computed, useAttrs } from 'vue'
import { useFormElementId } from '../../composables'

defineOptions({
  name: 'UiRadio',
  inheritAttrs: false,
})

const props = defineProps({
  disabled: {
    type: Boolean,
    default: false,
  },
  label: {
    type: String,
    default: '',
  },
  labelledById: {
    type: String,
    default: '',
  },
  name: {
    type: String,
    default: '',
  },
  modelValue: {
    type: [String, Number, Boolean],
    default: undefined,
  },
  value: {
    type: [String, Number, Boolean],
    default: undefined,
  },
  tabindex: {
    type: Number,
    default: undefined,
  },
  button: {
    type: Boolean,
    default: false,
  },
})

const filteredProps = computed(() => {
  const {
    label,
    labelledById,
    tabindex,
    button,
    modelValue,
    ...filteredProps
  } = props
  return filteredProps
})

const filteredAttrs = computed(() => {
  const { class: _, style, ...filteredAttrs } = useAttrs()
  return filteredAttrs
})

const emit = defineEmits(['update:modelValue'])

const model = computed({
  get: () => props.modelValue,
  set: (value) => {
    emit('update:modelValue', value)
  },
})

const { uniqueId } = useFormElementId(props)

const checked = computed(() => {
  return props.modelValue === props.value
})

const computedTabindex = computed(() => {
  if (checked.value) {
    return 0
  }

  if (props.tabindex !== undefined) {
    return props.tabindex
  }

  return -1
})
</script>
